﻿/*
 * * * Compile_AHK SETTINGS BEGIN * * *

[AHK2EXE]
Exe_File=%In_Dir%\Soundboard_V3.exe
No_UPX=1

* * * Compile_AHK SETTINGS END * * *
*/

#NoTrayIcon
#SingleInstance force
Splitpath, A_ScriptFullPath,,,,title
#NoEnv
SendMode Input
SetWorkingDir,%A_ScriptDir%

AnzahlButtons = 40

IniRead, ExtensionWanted, %title%.ini,SETTINGS,ExtensionWanted,%A_Space%
IniRead, AnzahlButtons, %title%.ini,SETTINGS,AmountButtons,%A_Space%
IniRead, DelayMS, %title%.ini,SETTINGS,DelayMS,%A_Space%

If DelayMS =
	DelayMS = 500

If ExtensionWanted =
{
	FileAppend,[SETTINGS],%title%.ini
	FileAppend,`nExtensionWanted = wav|mp3|ac3|ogg|mkv|mid|pls|mod|dts,%title%.ini
	FileAppend,`nAmountButtons=20,%title%.ini
	FileAppend,`nDelayMS=500
	Reload
	Return
}

If AnzahlButtons <> 40
	AnzahlButtons = 20

;;; GUI - 1 - Listview
Gui, Add, GroupBox, vGroupbox3 x05 y5 w245 h593,Folder
Gui, Add, TreeView, 0x80 0x20 vMyTreeView gTreeClick x15 y25 w225 h525 ,
Gui, Add, Button, gSilence vSilenceButton x13 y560 w70 h30 , &Silence
Gui, Add, Button, gGuiEscape vExit x170 y560 w70 h30 , E&xit
Gui, Add, Button, gVolumePlus vVolumePlus x93 y555 w70 h20 , Volume +
Gui, Add, Button, gVolumeMinus vVolumeMinus x93 y575 w70 h20 , Volume -



;;; GUI - 2 - Playlist
Gui, Add, GroupBox, vGroupbox2 x852 y10 w170 h588,Playlist
Gui, Add, ListView, -LV0x2000 -E0x2000 -Hdr vMyListView gListViewClick x861 y30 w150 h520 , Name|FullPath
Gui, Add, Button, gListViewPlayClick vListViewButton x915 y561 w80 h30 , &Play
Gui, Add, Button, gButtonUp vButtonUp x860 y555 w40 h20 , &Up
Gui, Add, Button, gButtonDown vButtonDown x860 y575 w40 h20 , &Down
LV_ModifyCol(1,125)
LV_ModifyCol(2,0)

;;; GUI - 3 - Tabs and Buttons
Gui, Add, GroupBox, vGroupbox x266 y37 w565 h535
Gui, Add, Tab, gTabs vTabs x256 y7 w590 h590 , 1|2|3|4|5|6|7|8|9|0

;;; GUI - 4 - Show this damn thing


gui, font, s32, Verdana
gui, font
Guicontrol,,Tabs,|
Gosub,ButtonCreate
Gui, Add, StatusBar,,Reading...
GuiControl,hide,SilenceButton
GuiControl,hide,VolumePlus
GuiControl,hide,VolumeMinus
GuiControl,hide,ButtonUp
GuiControl,hide,ButtonDown
GuiControl,hide,ListViewButton
GuiControl,hide,groupbox
GuiControl,hide,groupbox2
GuiControl,hide,mylistview
GuiControl,hide,listviewplayclick


Gui, Show,h620 w1024, %title%

P1 := TV_Add("Please wait!")
P1C1 := TV_Add("Buildling list...",P1)
TV_Modify(P1,"Expand")
Sleep,100
GuiControl,-Redraw,MyTreeView
GuiControl,disable,MyTreeView

TV_Delete()
Gosub,ReadTreeView
GuiControl,enable,MyTreeView

SB_SetText("Ready!")

TV_Modify(P1,"Select")
StartTree = P1|P1C1|P1C1C1|P1C1C1C1|P1C1C1C1C1
Loop,Parse,StartTree,|
{
	TV_Modify(%A_LoopField%,"Select")
	Gosub,TreeClick
	If Anzahl <> 0
		Break
}

Return


GuiEscape:
GuiClose:
ExitApp


;;; Startup - 10 - Treeview einlesen
ReadTreeView:
GuiControl, -Redraw, MyTreeView
TV_Delete()
Level1 = 1
Level2 = 1
Level3 = 1
Level4 = 1
Level5 = 1

Gesamt = 0
Loop,*.*,2     						; Level 1 nach Ordner durchsuchen
{
	Level1Folder = %A_LoopFileName%

	CheckAnzahl = 0					; Ordner nach Inhalt durchsuchen
	Loop,%Level1Folder%\*.*,1,1
		CheckAnzahl := CheckAnzahl +1
	If CheckAnzahl = 0
		CONTINUE

	FolderToCheck = %Level1Folder%			; Sounddateien prüfen
	GoSub,FolderCheck
	If FolderResult = 0
		CONTINUE

	P%Level1% := TV_Add(Level1Folder)
	Gesamt := Gesamt + 1



	Loop,%Level1Folder%\*.*,2			; Level 2 nach Ordner durchsuchen
	{

		Level2Folder = %Level1Folder%\%A_LoopFileName%

		CheckAnzahl = 0
		Loop,%Level2Folder%\*.*,1,1
			CheckAnzahl := CheckAnzahl +1
		If CheckAnzahl = 0
			CONTINUE

		FolderToCheck = %Level2Folder%
		GoSub,FolderCheck
		If FolderResult = 0
			CONTINUE

		P%Level1%C%Level2% := TV_Add(A_LoopFileName, P%Level1%)

		Loop,%Level2Folder%\*.*,2			; Level 3 nach Ordner durchsuchen
		{
			Level3Folder = %Level2Folder%\%A_LoopFileName%

			CheckAnzahl = 0
			Loop,%Level3Folder%\*.*,1,1
				CheckAnzahl := CheckAnzahl +1
			If CheckAnzahl = 0
				CONTINUE

			FolderToCheck = %Level3Folder%
			GoSub,FolderCheck
			If FolderResult = 0
				CONTINUE

			P%Level1%C%Level2%C%Level3% := TV_Add(A_LoopFileName, P%Level1%C%Level2%)

			Loop,%Level3Folder%\*.*,2			; Level 4 nach Ordner durchsuchen
			{
				Level4Folder = %Level3Folder%\%A_LoopFileName%

				CheckAnzahl = 0
				Loop,%Level4Folder%\*.*,1,1
					CheckAnzahl := CheckAnzahl +1
				If CheckAnzahl = 0
					CONTINUE

				FolderToCheck = %Level4Folder%
				GoSub,FolderCheck
				If FolderResult = 0
					CONTINUE

				P%Level1%C%Level2%C%Level3%C%Level4% := TV_Add(A_LoopFileName, P%Level1%C%Level2%C%Level3%)


				Loop,%Level4Folder%\*.*,2			; Level 5 nach Ordner durchsuchen
				{
					Level5Folder = %Level4Folder%\%A_LoopFileName%

					CheckAnzahl = 0
					Loop,%Level5Folder%\*.*,1,1
						CheckAnzahl := CheckAnzahl +1
					If CheckAnzahl = 0
						CONTINUE

					FolderToCheck = %Level5Folder%
					GoSub,FolderCheck
					If FolderResult = 0
						CONTINUE

					P%Level1%C%Level2%C%Level3%C%Level4%C%Level5% := TV_Add(A_LoopFileName, P%Level1%C%Level2%C%Level3%C%Level4%)

					Level5 := Level5 + 1
				}
				Level4 := Level4 + 1
			}
			Level3 := Level3 + 1
		}
		Level2 := Level2 + 1
	}
	Level1 := Level1 + 1
	Level2 = 1
	Level3 = 1
	Level4 = 1
	Level5 = 1
}

If Gesamt = 0
{
	Gui,Destroy
	Loop,Parse,ExtensionWanted,|
	{
		If List =
			List = - %A_LoopField%
		else
			List = %list%`n- %A_LoopField%
	}
	MsgBox,16,%title%,Create some subfolders and fill them with sound samples... Then start me again.`n`nI'm currently configured `("%title%.ini"`) to display following extensions:`n`n%List%
	ExitApp
}
GuiControl, +Redraw, MyTreeView
Return




FolderCheck:
FolderResult = 0
Loop,%FolderToCheck%\*.*,0,1
{
	SplitPath,A_LoopFileFullPath,,,CheckButtonExtension,CheckButtonName
	StringSplit,ExtensionSplit,ExtensionWanted,|
	Loop,%ExtensionSplit0%
	{
		ExtensionToCheck := ExtensionSplit%A_index%
		If CheckButtonExtension = %ExtensionToCheck%
		{
			FolderResult = 1
			Break
		}
	}
}
Return



;;; User click - 10 - Treeview click
TreeClick:
SelectedTray = 1
If FirstStart =
{
	GuiControl,show,SilenceButton
	GuiControl,show,VolumePlus
	GuiControl,show,VolumeMinus
	GuiControl,show,ButtonUp
	GuiControl,show,ButtonDown
	GuiControl,Show,ListViewButton
	GuiControl,Show,groupbox
	GuiControl,Show,groupbox2
	GuiControl,Show,mylistview
	GuiControl,Show,listviewplayclick
	FirstStart = 0
}

TreeClickButton:

Loop,%AnzahlButtons%0
{
	GuiControl,Hide,ButtonNr%A_Index%
	ButtonNr%A_Index% =
}

GuiControl,,Tabs,|(no files - check subfolder)

Ordner =
ID := TV_GetSelection()
Loop,5
{
	TV_GetText(Text,ID)
	%A_Index% := Text
	ID := TV_GetParent(ID)
}
Wert = 6
Loop,5
{
	Wert := Wert - 1
	Text := %Wert%
	If Text =
		Continue
	If Ordner =
		Ordner = %Text%
	else
		Ordner = %Ordner%\%Text%
}
; SB_SetText("Selected """ . Ordner . """")


;;; Startup - 30 - Anzahl Dateien = Anzahl Tabs
Anzahl = 0
DateiListe =
Loop,%Ordner%\*.*
{
	SplitPath,A_LoopFileFullPath,,,ButtonExtension,ButtonName
	StringSplit,ExtensionSplit,ExtensionWanted,|
	Loop,%ExtensionSplit0%
	{
		ExtensionToCheck := ExtensionSplit%A_index%
		If ButtonExtension = %ExtensionToCheck%
		{
			If DateiListe =
				DateiListe = %A_LoopFileName%
			else
				DateiListe = %DateiListe%`n%A_LoopFileName%
			Anzahl := Anzahl + 1
		}
	}
}

If Anzahl = 0
	Return

If AnzahlButtons = 20
{
	If Anzahl < 21
		GuiControl,,Tabs,|1
	else if (Anzahl > 20 and Anzahl < 41)
		GuiControl,,Tabs,|1|2
	else if (Anzahl > 40 and Anzahl < 61)
		GuiControl,,Tabs,|1|2|3
	else if (Anzahl > 60 and Anzahl < 81)
		GuiControl,,Tabs,|1|2|3|4
	else if (Anzahl > 80 and Anzahl < 101)
		GuiControl,,Tabs,|1|2|3|4|5
	else if (Anzahl > 100 and Anzahl < 121)
		GuiControl,,Tabs,|1|2|3|4|5|6
	else if (Anzahl > 121 and Anzahl < 141)
		GuiControl,,Tabs,|1|2|3|4|5|6|7
	else if (Anzahl > 141 and Anzahl < 161)
		GuiControl,,Tabs,|1|2|3|4|5|6|7|8
	else if (Anzahl > 160 and Anzahl < 181)
		GuiControl,,Tabs,|1|2|3|4|5|6|7|8|9
	else
		GuiControl,,Tabs,|1|2|3|4|5|6|7|8|9|0
}

If AnzahlButtons = 40
{
	If Anzahl < 41
		GuiControl,,Tabs,|1
	else if (Anzahl > 40 and Anzahl < 81)
		GuiControl,,Tabs,|1|2
	else if (Anzahl > 80 and Anzahl < 121)
		GuiControl,,Tabs,|1|2|3
	else if (Anzahl > 120 and Anzahl < 161)
		GuiControl,,Tabs,|1|2|3|4
	else if (Anzahl > 160 and Anzahl < 201)
		GuiControl,,Tabs,|1|2|3|4|5
	else if (Anzahl > 200 and Anzahl < 241)
		GuiControl,,Tabs,|1|2|3|4|5|6
	else if (Anzahl > 240 and Anzahl < 281)
		GuiControl,,Tabs,|1|2|3|4|5|6|7
	else if (Anzahl > 281 and Anzahl < 321)
		GuiControl,,Tabs,|1|2|3|4|5|6|7|8
	else if (Anzahl > 320 and Anzahl < 361)
		GuiControl,,Tabs,|1|2|3|4|5|6|7|8|9
	else
		GuiControl,,Tabs,|1|2|3|4|5|6|7|8|9|0
}

;;; User click - 11 - Buttons befüllen

Loop,%AnzahlButtons%0
{
	if A_Index > Anzahl
		GuiControl,Hide,ButtonNr%A_Index%
}


Loop, parse, DateiListe, `n, `r
{
	SplitPath,A_LoopField,,,ButtonExtension,ButtonName

	If AnzahlButtons = 40
	{
		StringLen, ButtonLaenge, ButtonName
		If ButtonLaenge > 45
		{
			StringLeft, ButtonName, ButtonName, 45
			ButtonName = %Buttonname%...
		}
	}

	GuiControl,,ButtonNr%A_Index%,%ButtonName%
	GuiControl,Show,ButtonNr%A_Index%
	ButtonNr%A_Index% = %Ordner%\%A_LoopField%
}
Return



;;; Startup - 20 - Buttons Create
ButtonCreate:
ButtonNr = 1

If AnzahlButtons = 20
{
	Loop,10
	{
		TabNr = %A_index%
		If A_Index = 10
			Tab = 0

		Gui,Tab,%TabNr%

		ButtonLine = 1

		Loop,20
		{
			If ButtonLine > 10
				xPos = 556
			else
				xpos = 276

			ButtonOffset := A_index * 50
			ypos := 7 + ButtonOffset
			If ButtonLine > 10
				ypos := ButtonOffset - 493

			Gui, Add, Button, gButtonClick vButtonNr%ButtonNr% x%xpos% y%ypos% w260 h40,%ButtonNr%

			ButtonLine := Buttonline + 1
			ButtonNr := ButtonNr + 1
		}
	}
}

If AnzahlButtons = 40
{
	Loop,10
	{
		TabNr = %A_index%
		If A_Index = 10
			Tab = 0

		Gui,Tab,%TabNr%

		ButtonLine = 1

		Loop,40
		{
			If ButtonLine > 20
				xPos = 556
			else
				xpos = 276

			ButtonOffset := A_index * 25
			ypos := 33 + ButtonOffset
			If ButtonLine > 20
				ypos := ButtonOffset - 467

			Gui, Add, Button, -Wrap gButtonClick vButtonNr%ButtonNr% x%xpos% y%ypos% w260 h20,%ButtonNr%

			ButtonLine := Buttonline + 1
			ButtonNr := ButtonNr + 1
		}
	}
}
Loop,%AnzahlButtons%0
	GuiControl,Hide,ButtonNr%A_Index%
Return



;;;User click - 20 - Button CLICK
ButtonClick:
PlayingContextMenu =
GuiButton = %A_GuiControl%
GetKeyState,KeyState,Shift
If Keystate = D
	Goto,RightclickRename

ButtonClickContext:
If PlayingContextMenu =
	GuiButton = %A_GuiControl%
else
	GuiButton = %PlayingContextMenu%
Playing := %GuiButton%
ButtonClickContextList:

If PlayListPlaying = 1
{
	PlayListPlayingStop = 1
	Gosub,Silence
}


If (LastPlayed = Playing and IsPlaying = 1)
{
	Gosub,Silence
	LastPlayed =
	Return
	SB_SetText("Ready!")
}
Gosub,Silence
SetTimer, PlayFile,-10
Return

PlayFile:
IsPlaying = 1
LastPlayed = %Playing%
SplitPath,Playing,,,,ButtonName
SB_SetText("Playing """ . ButtonName . """...")
SoundPlay,%Playing%,Wait
IsPlaying = 0
SB_SetText("Ready!")
Return




;;; GUI Context - 01 - Menu
GuiContextMenu:
Gui +OwnDialogs
If A_GuiEvent <> RightClick
	Return
If A_GuiControl = Exit
	Gosub,Reload
If A_GuiControl = MyListView
	Goto,ListViewClickRight
If A_GuiControl = MyTreeView
	Goto,TreeViewViewClickRight
If A_GuiControl = ListViewButton
	Goto,ListViewClickRight

If A_GuiControl contains ButtonNr
{
	PlayingContextMenu = %A_GuiControl%
	Playing := %A_GuiControl%
	if Playing =
		Return

	SplitPath,Playing,,,,ButtonName
	StringLen, ButtonLaenge, ButtonName
	If ButtonLaenge > 35
	{
		StringLeft, ButtonName, ButtonName, 35
		ButtonName = %Buttonname%...
	}

	Menu, RightClickMenu, Add
	Menu, RightClickMenu, DeleteAll
	Menu, RightClickMenu, Add, Play "%ButtonName%", RightClickPlay
	Menu, RightClickMenu, Add
	Menu, RightClickMenu, Add, Add to Pla&ylist, RightClickPlaylist
	Menu, RightClickMenu, Add, Add folder to Play&list, RightClickPlaylistAll
	Menu, RightClickMenu, Add
	Menu, RightClickMenu, Add, &Rename, RightclickRename
	StringLeft,FavCheck,Playing,11
	If FavCheck <> _Favorites\
		Menu, RightClickMenu, Add, &Delete, RightClickDelete
	Menu, RightClickMenu, Add
	If FavCheck <> _Favorites\
	{
		SplitPath,Playing,,OutDir,ButtonExtension,ButtonName
		IfExist,_Favorites\%ButtonName%.%ButtonExtension%
			Menu, RightClickMenu, Add, Remove from &Favorites, RightClickFavoritesRemove
		else
			Menu, RightClickMenu, Add, Copy to &Favorites, RightClickFavorites
	}
	If FavCheck = _Favorites\
		Menu, RightClickMenu, Add, Remove from &Favorites, RightClickFavoritesRemove
	Menu,RightClickMenu, Add, &Copy to folder, RightClickCopyFolder
	Menu, RightClickMenu, Add
	If AnzahlButtons = 20
		Menu, RightClickMenu, Add, Switch to &40 buttons per page,RightClick40
	If AnzahlButtons = 40
		Menu, RightClickMenu, Add, Switch to &20 buttons per page,RightClick20
	Menu, RightClickMenu, Add
	Menu, RightClickMenu, Add, Silence!,RightClickSilence
	Menu, RightClickMenu, Add,
	Menu, RightClickMenu, Add, E&xit, GUIEscape
}
else
{
	Menu, RightClickMenu, Add
	Menu, RightClickMenu, DeleteAll
	Menu, RightClickMenu, Add, Right-click on a button`, folder or playlist for more options,RightClickNothing
	Menu, RightClickMenu, Add,
	Menu, RightClickMenu, Add, Silence!,RightClickSilence
	Menu, RightClickMenu, Add,
	Menu, RightClickMenu, Add, E&xit, GUIEscape
}


Menu, RightClickMenu, Show
return

RightClickNothing:
Return



;;; GUI Context - 02 - RightClickCopyFolder
RightClickCopyFolder:

GetCurrentSelection := TV_GetSelection()
TV_GetText(IDSearchTextNeeded,GetCurrentSelection)

If CopyFolderDefault =
	CopyFolderDefault = %A_WorkingDir%
FileSelectFolder,SelectedCopyFolder,*%CopyFolderDefault%,3,Select target folder
If Errorlevel = 1
	Return
IfNotExist,%SelectedCopyFolder%
	Return
CopyFolderDefault = %SelectedCopyFolder%

SplitPath,Playing,,OutDir,ButtonExtension,ButtonName

FileCopyOldName = %A_workingdir%\%outdir%\%buttonname%.%buttonextension%
FileCopyNewName = %SelectedCopyFolder%\%buttonname%.%buttonextension%

if FileCopyOldName = %FileCopyNewName%
{
	SB_SetText("Target and source folder identical?!")
	Return
}

IfExist,%FileCopyNewName%
{
	Msgbox,36,%Title%,File "%buttonname%.%buttonextension%" exists in "%SelectedCopyFolder%"!`n`nOverwrite?
	IfMsgbox,No
		Return
}

FileCopy, %FileCopyOldName%, %FileCopyNewName%,1

SplitPath,FileCopyNewName,,OutDir,ButtonExtension,ButtonName
StringReplace,OutDir,OutDir,%A_workingdir%\

SB_SetText("File """ . ButtonName . """ copied to """ . FileCopyNewName . """")

ifexist,%A_workingdir%\%Outdir%
{
	Anzahl = 0
	Loop,%A_workingdir%\%Outdir%\*.*
	{
		SplitPath,A_LoopFileFullPath,,,ButtonExtension,ButtonName
		StringSplit,ExtensionSplit,ExtensionWanted,|
		Loop,%ExtensionSplit0%
		{
			ExtensionToCheck := ExtensionSplit%A_index%
			If ButtonExtension = %ExtensionToCheck%
			{
				If DateiListe =
					DateiListe = %A_LoopFileName%
				else
					DateiListe = %DateiListe%`n%A_LoopFileName%
				Anzahl := Anzahl + 1
				If Anzahl > 1
					Break
			}
			If Anzahl > 1
				Break
		}
		If Anzahl > 1
			Break
	}

	If Anzahl = 1
	{
		Gosub,ReadTreeView
		IDSearch := TV_GetNext()  ; Returns the first ID
		Loop
		{
			TV_GetText(IDSearchText,IDSearch)

			If IDSearchText = %IDSearchTextNeeded%
			{
				TV_Modify(IDSearch,"Select")
				Break
			}
			IDSearch := TV_GetNext(IDSearch, "Full")
		}
	}
}
Return




;;; GUI Context - 03 - 20 oder 40 Buttons
RightClick20:
IniWrite, 20, %title%.ini, SETTINGS, AmountButtons
Reload
Return

RightClick40:
IniWrite, 40, %title%.ini, SETTINGS, AmountButtons
Reload
return



;;; GUI Context - 04 - Remove from Favorites
RightClickFavoritesRemove:
SplitPath,Playing,,OutDir,ButtonExtension,ButtonName
If LastPlayed = %Playing%
	Gosub,Silence

If LastPlayed = %Playing%
	Gosub,Silence

FileDelete,%A_workingdir%\_Favorites\%ButtonName%.%ButtonExtension%
SB_SetText("Removed """ . ButtonName . """ from Favorites!")

FolderToCheck = _Favorites
GoSub,FolderCheck
If FolderResult = 0
	Gosub,ReadTreeView

Gosub,TreeClickButton
GuiControl,+Redraw, MyTreeView
Return




;;; GUI Context - 05 - Delete
RightClickDelete:
SplitPath,Playing,,OutDir,ButtonExtension,ButtonName

GetKeyState,KeyState,Shift
If Keystate <> D
{
	msgbox, 36, %title%, Delete "%ButtonName%"?
	IfMsgbox,No
		Return
	IfMsgbox,Cancel
		Return
}

If LastPlayed = %Playing%
	Gosub,Silence

FileDelete,%A_workingdir%\%OutDir%\%ButtonName%.%ButtonExtension%
SB_SetText("Deleted """ . ButtonName . """")

FolderToCheck = %outdir%			; Sounddateien prüfen
GoSub,FolderCheck
If FolderResult = 0
	Gosub,ReadTreeView

Gosub,TreeClickButton
GuiControl,+Redraw, MyTreeView
Return




;;; GUI Context - 06 - Copy to Favorites
RightClickFavorites:
StringLeft,FavCheck,Playing,11
SplitPath,Playing,,OutDir,ButtonExtension,ButtonName
ifexist, %A_workingdir%\_Favorites\%ButtonName%.%ButtonExtension%
{
	msgbox, 36, %title%, File "%A_workingdir%\_Favorites\%ButtonName%.%ButtonExtension%" already exists in favorites!`n`nOverwrite?
	IfMsgbox,No
		Return
	IfMsgbox,Cancel
		Return
}

IfNotExist,_Favorites
	FileCreateDir,_Favorites

FolderToCheck = _Favorites
GoSub,FolderCheck

FileCopy,%A_workingdir%\%OutDir%\%ButtonName%.%ButtonExtension%,%A_workingdir%\_Favorites\%ButtonName%.%ButtonExtension%,1
SB_SetText("Copied """ . ButtonName . """ to _Favorites")
If FolderResult = 0
	Gosub,ReadTreeView
Sleep,1500
Tooltip,
Return




;;; GUI Context - 07 - Rename
RightclickRename:
SplitPath,Playing,,OutDir,ButtonExtension,ButtonName

StringLen,ButtonNameLen,ButtonName
If ButtonNameLen < 50
	InputLen := ButtonNameLen * 8
else
	InputLen := ButtonNameLen * 7
If InputLen < 200
	InputLen = 200
If IntputLen > 650
	InputLen = 650

InputBox,NewFileName,%title%,New filename:,,%inputLen%,130,,,,,%ButtonName%
if errorlevel = 1
	Return
if NewFilename =
	Return
If NewFilename = %ButtonName%
	Return
StringReplace,Newfilename,Newfilename,:,_
StringReplace,Newfilename,Newfilename,?,.
StringReplace,Newfilename,Newfilename,<,_
StringReplace,Newfilename,Newfilename,>,_
StringReplace,Newfilename,Newfilename,|,_

ifexist, %A_workingdir%\%OutDir%\%NewFileName%.%ButtonExtension%
{
	msgbox, 36, %title%, File "%A_workingdir%\%OutDir%\%NewFileName%.%ButtonExtension%" already exists!`n`nOverwrite?
	IfMsgbox,No
		Return
	IfMsgbox,Cancel
		Return
}

If LastPlayed = %Playing%
	Gosub,Silence

FileMove,%A_workingdir%\%playing%,%A_workingdir%\%OutDir%\%NewFileName%.%ButtonExtension%,1
SB_SetText("Renamed """ . ButtonName . """ to """ . NewFileName """")
Gosub,TreeClickButton
GuiControl,Choose,Tabs,%SelectedTray%
GuiControl,+Redraw, MyTreeView
return




;;; GUI Context - 08 - Add to Playlist
RightClickPlaylist:
SplitPath,Playing,,OutDir,ButtonExtension,ButtonName
Temp = %A_WorkingDir%\%Playing%
Row := LV_Add("",ButtonName,Temp)
LV_Modify(Row, "Vis")
SB_SetText("Added """ . ButtonName . """ to Playlist.")
Return




;;; GUI Context - 08a - Add folder to Playlist
RightClickPlaylistAll:

Anzahl = 0
;SplitPath,Playing,,Ordner
Loop,%Ordner%\*.*
{
	SplitPath,A_LoopFileFullPath,,,ButtonExtension,ButtonName
	StringSplit,ExtensionSplit,ExtensionWanted,|
	Loop,%ExtensionSplit0%
	{
		ExtensionToCheck := ExtensionSplit%A_index%
		If ButtonExtension = %ExtensionToCheck%
		{
			Temp = %A_WorkingDir%\%Ordner%\%ButtonName%.%ButtonExtension%
			Row := LV_Add("",ButtonName,Temp)
			; LV_Modify(Row, "Vis")
			Anzahl := Anzahl + 1
		}
	}
}
SB_SetText("Added " . Anzahl . " files to Playlist.")
Return



;;; GUI Context - 09 - Silence
RightClickSilence:
Gosub,Silence
SB_SetText("Silenced!")
Return



;;; GUI Context - 10 - Play
RightClickPlay:
Gosub,ButtonClickContext
Return



;;; Various

Tabs:
Gui,Submit,Nohide
SelectedTray := %A_GuiControl%
AbortAutoPlay = 1
return




Reload:
Reload
Return

Silence:
Silenced = 1
SoundPlay,ThisFileNotHereItSeemsIsHelloYoda.uhf
Return




;;; User click - 30 - Playlist PLAY
ListViewPlayClick:

If PlaylistPlaying = 1
{
	PlayListPlayingStop = 1
	Gosub,Silence
	Return
}

AnzahlPlayList = 0
Loop % LV_GetCount()
	AnzahlPlayList := AnzahlPlayList + 1
If AnzahlPlayList = 0
{
	SB_SetText("Playlist seems to be empty...")
	Return
}

SetTimer,ListViewPlayClickPlaying,-50
Return

ListViewPlayClickPlaying:
GuiControl,,ListViewButton,&Stop
RowNumber = 0
OldRowNumber = 0
PlayListPlayingStop = 0
PlayListPlaying = 1
RowNumber := LV_GetNext(RowNumber)
If (RowNumber = 0 or Rownumber =)
	RowNumber = 1
Loop,
{

	If PlayListPlayingStop = 1
		Break

	If RowNumber = %OldRowNumber%
		Break

	OldRowNumber = %RowNumber%

	LV_Modify(RowNumber, "Select1")
	LV_Modify(RowNumber, "Focus")
	LV_Modify(RowNumber, "Vis")

	LV_GetText(Playing, RowNumber,2)

	SplitPath,Playing,,,,ButtonName
	SB_SetText("Playing """ . ButtonName . """...")
	SoundPlay,%Playing%,Wait
	If PlayListPlayingStop = 1
		Break

	Sleep,%DelayMS%

	LV_Modify(RowNumber, "Select0")
	RowNumber := RowNumber + 1
	If RowNumber > %AnzahlPlayList%
		Break
}

If (PlayListPlaying = 1 and PlayListPlayingStop = 1)
	SB_SetText("Playlist stopped!")
else
	SB_SetText("Ready!")
PlaylistPlaying = 0
GuiControl,,ListViewButton,&Play
Return




;;; ListViewClick - 10 - Init
ListViewClick:
FocusedRow = %A_EventInfo%
If FocusedRow = 0
	Return
If A_GuiEvent = DoubleClick
	Goto,ListViewDoubleClick
	Return

If A_GuiEvent = D		; Started Dragging
{
	msgbox,%A_EventInfo%
	Return
}

Return




;;; ListViewClick - 20 - Right Clicked
ListViewClickRight:
AnzahlPlayList = 0
Loop % LV_GetCount()
	AnzahlPlayList := AnzahlPlayList + 1
FocusedRow = %A_EventInfo%
If (FocusedRow = 0 and AnzahlPlayList = 0)
{
	Menu, RightClickList, Add
	Menu, RightClickList, DeleteAll
	Menu, RightClickList, Add, &Load playlist, ListViewClickLoad
	Menu, RightClickList, Add
	Menu, RightClickList, Add, Silence!,RightClickSilence
	Menu, RightClickList, Add,
	Menu, RightClickList, Add, E&xit, GUIEscape
	Menu, RightClickList, Show
	Return
}

Menu, RightClickList, Add
Menu, RightClickList, DeleteAll
Menu, RightClickList, Add, &Load playlist, ListViewClickLoad
Menu, RightClickList, Add, &Save playlist, ListViewClickSave
Menu, RightClickList, Add, &Edit playlist, ListViewClickEdit
Menu, RightClickList, Add
Menu, RightClickList, Add, Move Up, ButtonUp
Menu, RightClickList, Add, Move Down, ButtonDown
Menu, RightClickList, Add
Menu, RightClickList, Add, Delete from Playlist, DeleteFromPlaylist
Menu, RightClickList, Add
Menu, RightClickList, Add, &Randomize playlist, ListViewClickRandomize
Menu, RightClickList, Add, &Clear playlist, ListViewClickClear
Menu, RightClickList, Add
Menu, RightClickList, Add, Set &Delay,ListViewClickDelay
Menu, RightClickList, Add
Menu, RightClickList, Add, Silence!,RightClickSilence
Menu, RightClickList, Add,
Menu, RightClickList, Add, E&xit, GUIEscape
Menu, RightClickList, Show
return




;;; ListViewClick - 30 - Save Playlist
ListViewClickSave:

If ListViewOutput =
	ListViewOutput = %A_WorkingDir%\PlayList_%A_YYYY%_%A_MON%_%A_MDAY%.txt
FileSelectFile, ListViewOutput, 18, %ListViewOutput%, Name of playlist file.,*.txt
if errorlevel = 1
	Return

IfExist,%ListViewOutput%
	FileDelete,%ListViewOutput%

AnzahlPlayList = 0
Loop % LV_GetCount()
	AnzahlPlayList := AnzahlPlayList + 1

RowNumber = 1
OutputText =
Loop,
{
	LV_GetText(Playing, RowNumber,2)

	IfExist,%ListViewOutput%
		FileAppend,`n%Playing%,%ListViewOutput%
	else
		FileAppend,%Playing%,%ListViewOutput%

	RowNumber := RowNumber + 1
	If RowNumber > %AnzahlPlayList%
		Break
}
SB_SetText("Playlist saved in """ . ListViewOutput . """")

return




;;; ListViewClick - 40 - Load Playlist
ListViewClickLoad:
GuiDropped =
ListViewClickLoadGuiDropped:
If GuiDropped =
{
	If ListViewOutput =
		ListViewOutput = %A_WorkingDir%\*.txt
	FileSelectFile, ListViewOutput, 3, %ListViewOutput%, Name of playlist file.,*.txt
	if errorlevel = 1
		Return
}
else
	ListViewOutput = %GuiDropped%

AnzahlPlayList = 0
Loop % LV_GetCount()
	AnzahlPlayList := AnzahlPlayList + 1

If GuiDropped =
{
	If AnzahlPlayList <> 0
	{
		Msgbox,36,%title%,Append playlist to current playlist?
		IfMsgBox,No
			LV_Delete()
	}
}
Loop
{
	FileReadLine, FileReadLine, %ListViewOutput%, %A_Index%
	If Errorlevel = 1
		Break
	If FileReadLine =
		CONTINUE
	IfNotExist,%FileReadLine%
		CONTINUE
	SplitPath,FileReadLine,,OutDir,ButtonExtension,ButtonName
	Temp = %FileReadLine%
	LV_Add("",ButtonName,Temp)
}
SB_SetText("Playlist """ . ListViewOutput . """ loaded!")
return



;;; ListViewClick - 45 - Edit Playlist in Notepad
ListViewClickEdit:
Gui +OwnDialogs
AnzahlPlayList = 0
Loop % LV_GetCount()
	AnzahlPlayList := AnzahlPlayList + 1

RowNumber = 1
OutputText =
FileDelete,%A_Temp%\%title%_temp.txt
Loop,
{
	LV_GetText(Playing, RowNumber,2)

	IfExist,%A_Temp%\%title%_temp.txt
		FileAppend,`n%Playing%,%A_Temp%\%title%_temp.txt
	else
		FileAppend,%Playing%,%A_Temp%\%title%_temp.txt

	RowNumber := RowNumber + 1
	If RowNumber > %AnzahlPlayList%
		Break
}

Run,%A_Temp%\%title%_temp.txt
msgbox,65,%Title%,Opened the playlist in your editor.`n`nSave changes and then click OK to reload the playlist!
IfMsgBox,Cancel
{
	SB_SetText("Cancelled!")
	Return
}

LV_Delete()

Loop
{
	FileReadLine, FileReadLine, %A_Temp%\%title%_temp.txt, %A_Index%
	If Errorlevel = 1
		Break
	If FileReadLine =
		CONTINUE
	IfNotExist,%FileReadLine%
		CONTINUE
	SplitPath,FileReadLine,,OutDir,ButtonExtension,ButtonName
	Temp = %FileReadLine%
	LV_Add("",ButtonName,Temp)
}
SB_SetText("Edited playlist loaded!")
return




;;; ListViewClick - 50 - Clear Playlist
ListViewClickClear:
LV_Delete()
SB_SetText("Playlist cleared!")
return




;;; ListViewClick - 60 - Randomize Playlist
ListViewClickRandomize:

AnzahlPlayList = 0
Loop % LV_GetCount()
	AnzahlPlayList := AnzahlPlayList + 1

RowNumber = 1
outputtext =
Loop,
{
	LV_GetText(Wert1, RowNumber,1)
	LV_GetText(Wert2, RowNumber,2)

	If OutPutText =
		OutPutText = %Wert1%|%Wert2%
	else
		OutPutText = %OutPutText%`n%Wert1%|%Wert2%

	RowNumber := RowNumber + 1
	If RowNumber > %AnzahlPlayList%
		Break
}

sort,outputtext,random
LV_Delete()

Loop, parse, outputtext,`n, `r
{
	StringSplit,text,A_LoopField,|
	LV_Add("",text1,text2)
}
SB_SetText("Playlist randomized")
return




;;; ListViewClick - 70 - Playlist Delay
ListViewClickDelay:

InputBox, DelayMSNew,%Title%,Please enter the new delay between files in ms,,350,120,,,,,%DelayMS%
If Errorlevel = 1
	Return
If DelayMSNew =
	Return
If (DelayMSNew < 0 or DelayMSNew > 10000)
{
	SB_SetText("A delay of """ . DelayMSNew . """ is not supported. Sorry.")
	Return
}
DelayMS = %DelayMSNew%
IniWrite, %DelayMS%, %title%.ini, SETTINGS, DelayMS
If DelayMS = 0
	SB_SetText("Delay disabled")
else
	SB_SetText("Delay set to """ . DelayMSNew . """")
Return




;;; GUI - 5 - DropFiles on ListView
GuiDropFiles:
If A_GuiControl <> MyListView
	Return
Loop, parse, A_GuiEvent, `n
{
    GuiDropped = %A_LoopField%
    Break
}
IfNotExist,%GuiDropped%
	Return
Goto,ListViewClickLoadGuiDropped




;;; TreeViewRightClick - 10 - RightClickTreeView
TreeViewViewClickRight:
Menu, RightClickTreeList, Add
Menu, RightClickTreeList, DeleteAll
Menu, RightClickTreeList, Add, Add selected folder to Play&list,RightClickPlaylistAll
Menu, RightClickTreeList, Add
Menu, RightClickTreeList, Add, Silence!,RightClickSilence
Menu, RightClickTreeList, Add,
Menu, RightClickTreeList, Add, E&xit, GUIEscape
Menu, RightClickTreeList, Show
return



;;; ListViewDoubleClick
ListViewDoubleClick:
RowNumber := A_EventInfo
LV_GetText(Playing, RowNumber,2)
StringReplace,Playing,Playing,%A_WorkingDir%\,
If (LastPlayed = Playing and IsPlaying = 1)
{
	Gosub,Silence
	LastPlayed =
	Return
	SB_SetText("Ready!")
}
else
{
	Gosub,Silence
	SetTimer,ListViewDoubleClickGo,-50
}
Return

ListViewDoubleClickGo:
Gosub,ButtonClickContextList
Return



;;; VOLUME
VolumePlus:
VolumeAction = Plus
Goto,VolumePlusMinus
return

VolumeMinus:
VolumeAction = Minus
Goto,VolumePlusMinus
return

VolumePlusMinus:
SoundGetWaveVolume, WaveVolume
If WaveVolume =
{
	SB_SetText("Can't change volume. If Running Vista or Windows 7 please configure compatibility mode.")
	Return
}

If VolumeAction = Plus
	SoundSet, +5
else
	SoundSet, -5

SoundGet,MasterVolume
MasterVolume:=Round(MasterVolume),
SB_SetText("Volume level " . MasterVolume)
Return




;;; Playlist entries UP and DOWN
ButtonUp:
ButtonAction = Up
Goto,ButtonDownUpCommon

ButtonDown:
ButtonAction = Down
Goto,ButtonDownUpCommon

ButtonDownUpCommon:
AnzahlPlaylist = 0
Loop % LV_GetCount()
	AnzahlPlayList := AnzahlPlayList + 1
If AnzahlPlayList = 0
{
	SB_SetText("Playlist seems to be empty...")
	Return
}

RowNumber := LV_GetNext("","F")
If (RowNumber = 0 or Rownumber =)
{
	SB_SetText("Nothing selected...")
	Return
}

If ButtonAction = Down
{
	If RowNumber = %AnzahlPlayList%
		Return
	NewRow := Rownumber + 1
}
else
{
	If RowNumber = 1
		Return
	NewRow := RowNumber - 1
}

LV_GetText(First, RowNumber,1)
LV_GetText(Second, RowNumber,2)
LV_Delete(RowNumber)
LV_Insert(NewRow,"Focus Select",First,Second)
LV_Modify(NewRow, "Vis")
Return




;;; Delete from Playlist
DeleteFromPlaylist:
RowNumber := LV_GetNext("","F")
If (RowNumber = 0 or Rownumber =)
{
	SB_SetText("Nothing selected...")
	Return
}
LV_Delete(RowNumber)
Return